



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>并发编程——详解 AQS CLH 锁</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">并发编程——详解 AQS CLH 锁</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-04 17:30:02 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<ol><li>从 acquire 方法开始 —— 获取</li>
<li>为什么 AQS 需要一个虚拟 head 节点</li>
<li>reelase 方法如何释放锁</li>
<li>总结</li></ol>
<h2>前言</h2>
<p>AQS 是 JUC 中的核心，其中封装了资源的获取和释放，在我们之前的  <a href="http://thinkinjava.cn/article/50" rel="external nofollow noreferrer">并发编程之 AQS 源码剖析</a> 文章中，我们已经从 ReentranLock 那里分析了锁的获取和释放。但我有必要再次解释 AQS 的核心 CLH 锁。</p>
<p>这里引用一下别人对于 CLH 的解释：</p>
<blockquote><p>CLH CLH(Craig, Landin, and Hagersten  locks): 是一个自旋锁，能确保无饥饿性，提供先来先服务的公平性。</p></blockquote>
<blockquote><p>CLH锁也是一种基于链表的可扩展、高性能、公平的自旋锁，申请线程只在本地变量上自旋，它不断轮询前驱的状态，如果发现前驱释放了锁就结束自旋。</p></blockquote>
<p>Java AQS 的设计对 CLH 锁进行了优化或者说变体。</p>
<p>我们还是从代码开始说起吧。</p>
<h2>1. 从 acquire 方法开始 —— 获取</h2>
<p>acquire 方法是获取锁的常用方法。代码如下：</p>
<pre class="prettyprint linenums"><code>public final void acquireQueued(int arg) {<br />
	// 当 tryAcquire 返回 true 就说明获取到锁了，直接结束。<br />
	// 反之，返回 false 的话，就需要执行后面的方法。<br />
    if (!tryAcquire(arg) &amp;&amp;<br />
        acquireQueued(addWaiter(Node.EXCLUSIVE), arg))<br />
        selfInterrupt();<br />
}<br />
</code></pre>
<p>只要子类的 tryAcquire 方法返回 false，那么就说明获取锁事变，就需要将自己加入队列。</p>
<pre class="prettyprint linenums"><code>private Node addWaiter(Node mode) {<br />
	// 创建一个独占类型的节点<br />
    Node node = new Node(Thread.currentThread(), mode);<br />
    // Try the fast path of enq; backup to full enq on failure<br />
    Node pred = tail;<br />
    // 如果 tail 节点不是 null，就将新节点的 pred 节点设置为 tail 节点。<br />
    // 并且将新节点设置成 tail 节点。<br />
    if (pred != null) {<br />
        node.prev = pred;<br />
        if (compareAndSetTail(pred, node)) {<br />
            pred.next = node;<br />
            return node;<br />
        }<br />
    }<br />
    // 如果 tail 节点是  null，或者 CAS 设置 tail 失败。<br />
    // 在 enq 方法中处理<br />
    enq(node);<br />
    return node;<br />
}<br />
</code></pre>
<p>将自己加入了尾部，并更新了 tail 节点。</p>
<pre class="prettyprint linenums"><code>private Node enq(final Node node) {<br />
    for (;;) {<br />
        Node t = tail;<br />
        // 如果 tail 是 null，就创建一个虚拟节点，同时指向 head 和 tail，称为 初始化。<br />
        if (t == null) { // Must initialize<br />
            if (compareAndSetHead(new Node()))<br />
                tail = head;<br />
        } else {// 如果不是 null<br />
        	// 和 上个方法逻辑一样，将新节点追加到 tail 节点后面，并更新队列的 tail 为新节点。<br />
        	// 只不过这里是死循环的，失败了还可以再来 。<br />
            node.prev = t;<br />
            if (compareAndSetTail(t, node)) {<br />
                t.next = node;<br />
                return t;<br />
            }<br />
        }<br />
    }<br />
}<br />
</code></pre>
<p>enq 方法的逻辑是什么呢？当 tail 是 null（没有初始化队列），就需要初始化队列了。CAS 设置  tail 失败，也会走这里，需要在 enq 方法中循环设置 tail。直到成功。</p>
<p>注意：这里会创建一个<strong>虚拟节点。</strong></p>
<h2>2. 为什么 AQS 需要一个虚拟 head 节点</h2>
<p>为什么要创建一个虚拟节点呢？</p>
<p>事情要从 Node 类的 waitStatus 变量说起，简称 ws。每个节点都有一个 ws 变量，用于这个节点状态的一些标志。初始状态是 0。如果被取消了，节点就是 1，那么他就会被 AQS 清理。</p>
<p>还有一个重要的状态：SIGNAL —— -1，表示：当当前节点释放锁的时候，需要唤醒下一个节点。</p>
<p>所有，每个节点在休眠前，都需要将前置节点的 ws 设置成 SIGNAL。<strong>否则自己永远无法被唤醒</strong>。</p>
<p>而为什么需要这么一个 ws 呢？—— 防止重复操作。假设，当一个节点已经被释放了，而此时另一个线程不知道，再次释放。这时候就错误了。</p>
<p>所以，需要一个变量来保证这个节点的状态。而且修改这个节点，必须通过 CAS 操作保证线程安全。</p>
<p>So，回到我们之前的问题：为什么要创建一个虚拟节点呢？</p>
<p>每个节点都必须设置前置节点的 ws 状态为 SIGNAL，所以必须要一个前置节点，而这个前置节点，实际上就是当前持有锁的节点。</p>
<p>问题在于有个边界问题：<strong>第一个节点怎么办？</strong>他是没有前置节点的。</p>
<blockquote><p>那就创建一个假的。</p></blockquote>
<p>这就是为什么要创建一个虚拟节点的原因。</p>
<p>总结下来就是：<strong>每个节点都需要设置前置节点的 ws 状态（这个状态为是为了保证数据一致性），而第一个节点是没有前置节点的，所以需要创建一个虚拟节点</strong>。</p>
<p>回到我们的 acquireQueued 方法证实一下：</p>
<pre class="prettyprint linenums"><code>// 这里返回的节点是新创建的节点，arg 是请求的数量<br />
final boolean acquireQueued(final Node node, int arg) {<br />
    boolean failed = true;<br />
    try {<br />
        boolean interrupted = false;<br />
        for (;;) {<br />
        	// 找上一个节点<br />
            final Node p = node.predecessor();<br />
            // 如果上一个节点是 head ，就尝试获取锁<br />
            // 如果 获取成功，就将当前节点设置为 head，注意 head 节点是永远不会唤醒的。<br />
            if (p == head &amp;&amp; tryAcquire(arg)) {<br />
                setHead(node);<br />
                p.next = null; // help GC<br />
                failed = false;<br />
                return interrupted;<br />
            }<br />
            // 在获取锁失败后，就需要阻塞了。<br />
            // shouldParkAfterFailedAcquire ---&gt; 检查上一个节点的状态，如果是 SIGNAL 就阻塞，否则就改成 SIGNAL。<br />
            if (shouldParkAfterFailedAcquire(p, node) &amp;&amp;<br />
                parkAndCheckInterrupt())<br />
                interrupted = true;<br />
        }<br />
    } finally {<br />
        if (failed)<br />
            cancelAcquire(node);<br />
    }<br />
}<br />
</code></pre>
<p>这个方法有 2 个逻辑：</p>
<ol><li>如何将自己挂起？</li>
<li>被唤醒之后做什么？</li></ol>
<p>先回答第二个问题： 被唤醒之后做什么？</p>
<p>尝试拿锁，成功之后，将自己设置为 head，断开和 next 的连接。</p>
<p>再看第二个问题：如何将自己挂起？</p>
<p>注意：挂起自己之前，需要将前置节点的 ws 状态设置成 SIGNAL，告诉他：你释放锁的时候记得唤醒我。</p>
<p>具体逻辑在 shouldParkAfterFailedAcquire 方法中：</p>
<pre class="prettyprint linenums"><code>private static boolean shouldParkAfterFailedAcquire(Node pred, Node node) {<br />
    int ws = pred.waitStatus;<br />
    //  如果他的上一个节点的 ws 是 SIGNAL，他就需要阻塞。<br />
    if (ws == Node.SIGNAL)<br />
    	// 阻塞<br />
        return true;<br />
    // 前任被取消。 跳过前任并重试。<br />
    if (ws &gt; 0) {<br />
        do {<br />
        	// 将前任的前任 赋值给 当前的前任<br />
            node.prev = pred = pred.prev;<br />
        } while (pred.waitStatus &gt; 0);<br />
        // 将前任的前任的 next 赋值为 当前节点<br />
        pred.next = node;<br />
    } else {<br />
    	// 如果没有取消 || 0 || CONDITION || PROPAGATE，那么就将前任的 ws 设置成 SIGNAL.<br />
    	// 为什么必须是 SIGNAL 呢？<br />
    	// 答：希望自己的上一个节点在释放锁的时候，通知自己（让自己获取锁）<br />
        compareAndSetWaitStatus(pred, ws, Node.SIGNAL);<br />
    }<br />
    // 重来<br />
    return false;<br />
}<br />
</code></pre>
<p>该方法的主要逻辑就是将前置节点的状态修改成 SIGNAL。其中如果前置节点被取消了，就跳过他。</p>
<p>那么肯定，在前置节点释放锁的时候，肯定会唤醒这个节点。看看释放的逻辑吧。</p>
<h2>3. reelase 方法如何释放锁</h2>
<p>先来一波代码:</p>
<pre class="prettyprint linenums"><code>public final boolean release(int arg) {<br />
    if (tryRelease(arg)) {<br />
        Node h = head;<br />
        // 所有的节点在将自己挂起之前，都会将前置节点设置成 SIGNAL，希望前置节点释放的时候，唤醒自己。<br />
        // 如果前置节点是 0 ，说明前置节点已经释放过了。不能重复释放了，后面将会看到释放后会将 ws 修改成0.<br />
        if (h != null &amp;&amp; h.waitStatus != 0)<br />
            unparkSuccessor(h);<br />
        return true;<br />
    }<br />
    return false;<br />
}<br />
</code></pre>
<p>从这个方法的判断就可以看出，head 必须不等于 0。为什么呢？当一个节点尝试挂起自己之前，都会将前置节点设置成 SIGNAL -1，就算是第一个加入队列的节点，在获取锁失败后，也会将虚拟节点设置的 ws 设置成 SIGNAL。</p>
<p>而这个判断也是防止多线程重复释放。</p>
<p>那么肯定，在释放锁之后，肯定会将 ws 状态设置成 0。防止重复操作。</p>
<p>代码如下：</p>
<pre class="prettyprint linenums"><code>private void unparkSuccessor(Node node) {<br />
    int ws = node.waitStatus;<br />
    if (ws &lt; 0)<br />
    	// 将 head 节点的 ws 改成 0，清除信号。表示，他已经释放过了。不能重复释放。<br />
        compareAndSetWaitStatus(node, ws, 0);

    Node s = node.next;<br />
    // 如果 next 是 null，或者 next 被取消了。就从 tail 开始向上找节点。<br />
    if (s == null || s.waitStatus &gt; 0) {<br />
        s = null;<br />
        // 从尾部开始，向前寻找未被取消的节点，直到这个节点是 null，或者是 head。<br />
        // 也就是说，如果 head 的 next 是 null，那么就从尾部开始寻找，直到不是 null 为止，找到这个 head 就不管了。<br />
        // 如果是 head 的 next 不是 null，但是被取消了，那这个节点也会被略过。<br />
        for (Node t = tail; t != null &amp;&amp; t != node; t = t.prev)<br />
            if (t.waitStatus &lt;= 0)<br />
                s = t;<br />
    }<br />
    // 唤醒 head.next 这个节点。<br />
    // 通常这个节点是 head 的 next。<br />
    // 但如果 head.next 被取消了，就会从尾部开始找。<br />
    if (s != null)<br />
        LockSupport.unpark(s.thread);<br />
}<br />
</code></pre>
<p>如果 ws 小于 0，我们假设是 SIGNAL，就修改成 0.  证实了我们的想法。</p>
<p>如果他的 next 是 null，说明 next 取消了，那么就从尾部开始向上寻找（不从尾部也没办法）。当然找的过程中，也跳过了失效的节点。</p>
<p>最后，唤醒他。</p>
<p>唤醒之后的逻辑是什么样子的还记得吗？</p>
<p>复习一下：拿锁，设置自己为 head，断开前任 head 和自己的连接。</p>
<h2>4. 总结</h2>
<p>AQS 使用的 CLH 锁，需要一个虚拟 head 节点，这个节点的作用是防止重复释放锁。当第一个进入队列的节点没有前置节点的时候，就会创建一个虚拟的。</p>
<p>来一幅图尝试解释 AQS 吧：</p>
<ol><li><p>新增节点时<br /><br />
<img referrerpolicy="no-referrer"src="https://upload-images.jianshu.io/upload_images/4236553-d84d01082e8d1765.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240"></p></li>
<li><p>更新 tail</p></li></ol>
<p><img referrerpolicy="no-referrer"src="https://upload-images.jianshu.io/upload_images/4236553-73807009865edd6b.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240"></p>
<ol><li>唤醒节点时，之前的 head 取消了</li></ol>
<p><img referrerpolicy="no-referrer"src="https://upload-images.jianshu.io/upload_images/4236553-b7ca9dc21e29bc6b.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240"></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qngrgx8.html">发现一个百度的密码。。。记最近一段时间的php感想</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mr37o9.html">SAP查询事务、表属于哪个模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/96oopn39.html">sql server日期时间函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwddoez8.html">mac下pmset的使用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmg1319.html">web&period;py安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1rddzq.html">Ionic2 &plus; Angular4 &plus; JSSDK开发中的若干问题汇总</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo6plxq.html">JSON【介绍、语法、解析JSON】</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj4y0g8.html">JMeter 压力测试使用CSV参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj2wme9.html">Micropython 如何用Turnipbit做一个自动浇水装置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjo4lk8.html">CSS3 border-radius 圆角</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyo2z39.html">TreeView的三种状态，全选，全不选，半选中</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyvg1mq.html">replace函数使用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv5jjl8.html">Linux：去除每一行行首的空格</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdy06e9.html">初始FreeMake</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o5onx8.html">【MySQL】【一】shell</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wz440q.html">对spark算子aggregateByKey的理解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1zy31q.html">mysql数据库主从同步读写分离（一）主从同步</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jee13q.html">数据仓库四个特点（面向主题的（Subject Oriented）、集成的（Integrate）、相对稳定的（Non-Volatile）、反映历史变化（Time Variant））</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvevy7o9.html">【AtCoder】ARC084</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pyr05q.html">循序渐进学&period;Net Core Web Api开发系列【3】：WebApi开发概览</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qv2xmkj9.html">1&period; Ubuntu下MongoDB的安装和使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwzozy8.html">hdu 1&period;2&period;5</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1re7k68.html">Linux下SVN配置hook经验总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25rpvvq.html">浏览器环境下JavaScript脚本加载与执行探析之defer与async特性</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rozr49.html">201621123018《Java程序设计》第7周学习报告</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjwydr9.html">JQuery  知识</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwz01y8.html">collections&comma; time&comma; queue的应用</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5oo5mq.html">在window主机上访问virtualbox虚拟机上centos7的tomcat服务</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4ddwk9.html">一次对路边饮用水RFID供应机的跑路玩法</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwz1178.html">WebRTC开发基础（WebRTC入门系列3：RTCDataChannel）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
